/*
 * Jakelib2 - General purpose C++ library
 * Copyright (C) 2001 Florian Wolff  (florian@donuz.de)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: Properties.h,v 1.15 2002/06/08 10:09:42 florian Exp $
 */

#ifndef INCLUDE_JAKELIB2_UTIL_PROPERTIES_H
# define INCLUDE_JAKELIB2_UTIL_PROPERTIES_H
# include "Hashtable.h"

namespace jakelib {
  namespace io {
    class BufferedReader;
    class OutputStream;
  }
  namespace util {

    /**
     *
     * @class Properties
     * @version $Id: Properties.h,v 1.15 2002/06/08 10:09:42 florian Exp $
     * @author Florian 'Overflo' Wolff (florian@donuz.de)
     */
    class Properties : public Hashtable
      {
      public:
	Properties();
	Properties(Properties* defaults);

	JAKELIB_DECLARE_CLASS(Properties);

	jakelib::lang::String* getProperty(jakelib::lang::String* key);
	jakelib::lang::String* getProperty(char* key);
	jakelib::lang::String* getProperty(jakelib::lang::String* key, jakelib::lang::String* defaultValue);
	jakelib::lang::String* getProperty(char* key, char* defaultValue);
	void load(jakelib::io::BufferedReader* in);
	void load(char* filename);
	void load(jakelib::lang::String* filename);
	void setProperty(jakelib::lang::String* key, jakelib::lang::String* value);
	void setProperty(char* key, char* value);
	void store(jakelib::io::OutputStream* out, jakelib::lang::String* header);
	jboolean getBoolean(char* key, jboolean defaultValue);
	jboolean getBoolean(jakelib::lang::String* key, jboolean defaultValue);
	int getInt(char* key, int defaultValue);
	int getInt(jakelib::lang::String* key, int defaultValue);
  
      protected:
	Properties* defaults;
      };

  }
}
#endif

